var __defProp = Object.defineProperty;
var __typeError = (msg) => {
  throw TypeError(msg);
};
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
var __accessCheck = (obj, member, msg) => member.has(obj) || __typeError("Cannot " + msg);
var __privateAdd = (obj, member, value) => member.has(obj) ? __typeError("Cannot add the same private member more than once") : member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
var __privateMethod = (obj, member, method) => (__accessCheck(obj, member, "access private method"), method);
var _ViewSync_instances, bindInputEvents_fn, updateValue_fn, convertValue_fn;
const _ViewSync = class _ViewSync {
  constructor() {
    __privateAdd(this, _ViewSync_instances);
    __publicField(this, "syncedElements", {});
    const elements = document.querySelectorAll("[data-sync-init]");
    elements.forEach((el) => {
      const id = el.getAttribute("data-sync-init");
      const value = el.getAttribute("data-sync-value");
      if (!id) return;
      this.syncedElements[id] = {
        id,
        value: __privateMethod(this, _ViewSync_instances, convertValue_fn).call(this, value),
        source: el,
        elements: []
      };
      const inputs = el.querySelectorAll(`[data-sync="${id}"]`);
      const texts = el.querySelectorAll(`[data-sync-text="${id}"]`);
      const states = el.querySelectorAll(`[data-sync-state="${id}"]`);
      inputs.forEach((el2) => {
        if (el2 instanceof HTMLInputElement || el2 instanceof HTMLTextAreaElement) {
          this.syncedElements[id].elements.push({
            element: el2,
            type: "input"
          });
        }
      });
      texts.forEach((el2) => {
        if (el2 instanceof HTMLElement) {
          this.syncedElements[id].elements.push({
            element: el2,
            type: "text"
          });
        }
      });
      states.forEach((el2) => {
        if (el2 instanceof HTMLElement) {
          this.syncedElements[id].elements.push({
            element: el2,
            type: "state"
          });
        }
      });
      __privateMethod(this, _ViewSync_instances, bindInputEvents_fn).call(this, this.syncedElements[id]);
    });
  }
  static Init() {
    return new _ViewSync();
  }
};
_ViewSync_instances = new WeakSet();
bindInputEvents_fn = function(syncedElements) {
  syncedElements.elements.filter((el) => el.element instanceof HTMLInputElement || el.element instanceof HTMLTextAreaElement).forEach((el) => {
    const element = el.element;
    if (element instanceof HTMLInputElement || element instanceof HTMLTextAreaElement) {
      el.element.addEventListener("input", () => {
        __privateMethod(this, _ViewSync_instances, updateValue_fn).call(this, syncedElements, element);
      });
    }
  });
};
updateValue_fn = function(syncedElements, element) {
  const value = element.value;
  syncedElements.value = __privateMethod(this, _ViewSync_instances, convertValue_fn).call(this, value);
  syncedElements.elements.forEach((el) => {
    if (el.element !== element) {
      switch (el.type) {
        case "input":
          el.element.value = value;
          break;
        case "text":
          el.element.textContent = value;
          break;
        case "state":
          if (!!syncedElements.value) {
            el.element.style.removeProperty("display");
          } else {
            el.element.style.display = "none";
          }
          break;
      }
    }
  });
};
convertValue_fn = function(value) {
  switch (value) {
    case "null":
    case null:
      return null;
    case "true":
      return true;
    case "false":
      return false;
    default:
      if (!isNaN(Number(value))) {
        return Number(value);
      }
      return value;
  }
};
let ViewSync = _ViewSync;
export {
  ViewSync
};
//# sourceMappingURL=view-sync.mjs.map
